{{
************************************************************
* File jvmStore: storing stack values into local variables *
************************************************************
}}


OBJ
  js: "jvmStack"
  jc: "jvmConvert"
  jd: "jvmData"
  
  
PUB jb_istore | fp,index,val
{{ Meaning: Store integer into local variable. }}
{{
  JEM format: istore,byte1
  byte1 is the index of the local variable.
}}
  index := jd.readJavaByte(jd.getJvmPC+1)
  val := js.jb_pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(2)
  

PUB jb_istore_0 | fp,val
{{ Meaning: Store integer into local variable with index 0. }}
{{
  JEM format: istore_0
}}
  val := js.jb_pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp,val)
  jd.incJvmPC(1)
  

PUB jb_istore_1 | fp,val
{{ Meaning: Store integer into local variable with index 1. }}
{{
  JEM format: istore_1
}}
  val := js.jb_pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 2,val)
  jd.incJvmPC(1)


PUB jb_istore_2 | fp,val
{{ Meaning: Store integer into local variable with index 2. }}
{{
  JEM format: istore_2
}}
  val := js.jb_pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 4,val)
  jd.incJvmPC(1)


PUB jb_istore_3 | fp,val
{{ Meaning: Store integer into local variable with index 3. }}
{{
  JEM format: istore_3
}}
  val := js.jb_pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 6,val)
  jd.incJvmPC(1)


{{PUB jb_lstore}}
{{ Meaning: Store long integer into local variable. }}


{{PUB jb_lstore_0}}
{{ Meaning: Store long integer into local variable with index 0. }}


{{PUB jb_lstore_1}}
{{ Meaning: Store long integer into local variable with index 1. }}


{{PUB jb_lstore_2}}
{{ Meaning: Store long integer into local variable with index 2. }}


{{PUB jb_lstore_3}}
{{ Meaning: Store long integer into local variable with index 3. }}


{{PUB jb_fstore}}
{{ Meaning: Store single float into local variable. }}


{{PUB jb_fstore_0}}
{{ Meaning: Store single float into local variable with index 0. }}


{{PUB jb_fstore_1}}
{{ Meaning: Store single float into local variable with index 1. }}


{{PUB jb_fstore_2}}
{{ Meaning: Store single float into local variable with index 2. }}


{{PUB jb_fstore_3}}
{{ Meaning: Store single float into local variable with index 3. }}


{{PUB jb_dstore}}
{{ Meaning: Store double-precision floating-point number into local variable. }}


{{PUB jb_dstore_0}}
{{ Meaning: Store double float into local variable with index 0. }}


{{PUB jb_dstore_1}}
{{ Meaning: Store double float into local variable with index 1. }}


{{PUB jb_dstore_2}}
{{ Meaning: Store double float into local variable with index 2. }}


{{PUB jb_dstore_3}}
{{ Meaning: Store double float into local variable with index 3. }}


{{PUB jb_astore}}
{{ Meaning: Store object reference into local variable. }}


{{PUB jb_astore_0}}
{{ Meaning: Store object reference into local variable with index 0. }}


{{PUB jb_astore_1}}
{{ Meaning: Store object reference into local variable with index 1. }}


{{PUB jb_astore_2}}
{{ Meaning: Store object reference into local variable with index 2. }}


{{PUB jb_astore_3}}
{{ Meaning: Store object reference into local variable with index 3. }}


PUB iinc | fp,index,val
{{ Meaning: Increment local variable by constant. }}
{{
  JEM format: iinc,byte1,byte2
  byte1 is the index of the local variable. byte2 is the signed 1byte value to add to local variable.
}}
  index := jd.readJavaByte(jd.getJvmPC+1)
  val := jd.readJavaByte(jd.getJvmPC+2)
  val := jc.jb_b2i(val)
  fp := jd.getJvmFP
  val += jd.readJavaIntBE(fp + (index<<1))
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(3)
  
